'''Anything that flies'''

from mob import *
from random import *

MOVESPEED = 400.0
MINMOVESPEED = 120.0
FRAMETIME = 100.0

class Bird(Mob):
    def __init__(self, g, basename = 'bluebird', xpos = 400.0, ypos = 350.0):
        Mob.__init__(self, g, basename, xpos, ypos)
        self.type = 'bird'

    def _ai(self):
        if self.state == 'runaway':
            return
        if self.state == 'wait':
            self.xpos = MINX + random() * (MAXX - MINX)
            if self.basename == 'bat':
                self.ypos = GROUNDY + 50.0 + random() * 200.0
            else:
                self.ypos = MINY + random() * (GROUNDY - MINY)
            self.rect.midbottom = (self.xpos, self.ypos)
        if random() > 0.3 or self.basename == 'bat':
            self.state = 'fly'
            self.xspeed = random() * MOVESPEED * 2 - MOVESPEED
            if abs(self.xspeed) < MINMOVESPEED:
                self.xspeed += self.xspeed / abs(self.xspeed) * MINMOVESPEED
            self.yspeed = random() * MOVESPEED * 2 - MOVESPEED
            if abs(self.yspeed) < MINMOVESPEED:
                self.yspeed += self.yspeed / abs(self.yspeed) * MINMOVESPEED
            if self.xspeed < 0:
                self.direction = 0
            else:
                self.direction = 1
        else:
            self.state = 'stand'
            self.xspeed = self.yspeed = 0
        self.timeremain = random() * MAXTIME + MINTIME
        self._setimage()

    def _process_state(self):
        if self.state == 'runaway':
            self.xpos += self.xspeed * self.dt / 1000.0
            self.rect.centerx = self.xpos
            if self.xpos < -100.0 or self.xpos > 900.0:
                self.state = 'wait'
                self.timeremain = 5000.0 + random() * 20000.0
            return
        if self.state == 'fly':
            newx = self.xpos + self.xspeed * self.dt / 1000.0
            if newx < MINX or newx > MAXX:
                self.reverse()
                newx = self.xpos
            else:
                self.xpos = newx
            newy = self.ypos + self.yspeed * self.dt / 1000.0
            if self.basename == 'bat':
                if newy < 400.0 or newy > 550.0:
                    self.yspeed = -self.yspeed
                    newy = self.ypos
                else:
                    self.ypos = newy
            else:
                if newy < MINY or newy > GROUNDY:
                    self.yspeed = -self.yspeed
                    newy = self.ypos
                else:
                    self.ypos = newy
            self.rect.midbottom = (self.xpos, self.ypos)

    def _animstate(self):
        if self.animstate == 'runaway' or self.animstate == 'fly':
            self.animframe = self.animframe % 2 + 1
            self._setimage()


            

