import mob

TOPY = 350.0 + 20.0
BOTTOMY = 550.0 + 10.0
SPEED = 400.0

class Elevator(mob.Mob):
    def __init__(self, g, xpos):
        mob.Mob.__init__(self, g, 'elevator', xpos, BOTTOMY)
        self.type = 'elevator'
        self.state = 'bottom'

    def _setimage(self):
        self.image = self.g.res.images['elevator']
        self.rect = self.image.get_rect()
        self.rect.midbottom = (self.xpos, self.ypos)

    def trigger(self, action):
        if action == 'on':
            self.state = 'raise'
        elif action == 'off':
            self.state = 'lower'

    def _process_state(self):
        if self.state == 'raise':
            if self.ypos < TOPY:
                self.ypos = TOPY
                self.state = 'top'
            else:
                self.ypos -= SPEED * self.dt / 1000.0
                self._setimage()
        elif self.state == 'lower':
            if self.ypos > BOTTOMY:
                self.ypos = BOTTOMY
                self.state = 'bottom'
            else:
                self.ypos += SPEED * self.dt / 1000.0
                self._setimage()




