'''score and other info'''

import pygame

class Hud(object):
    def __init__(self, g):
        self.g = g
        self.lastscore = 0
        self.lastanger = 0
        self.battery = 100
        self.font = pygame.font.SysFont('Courier', 30, bold=True)
        self.spritegroup = pygame.sprite.RenderUpdates()
        self.scoresprite = pygame.sprite.Sprite()
        self.scoresprite.image = \
            self.font.render("Score: " + str(self.lastscore), True,
                             (255, 255, 0))
        self.scoresprite.rect = self.scoresprite.image.get_rect()
        self.scoresprite.rect.topleft = (85, 5)
        self.spritegroup.add(self.scoresprite)
        self.tapestate = 'off'
        self.tapesprite = pygame.sprite.Sprite()
        self.tapesprite.image = g.res.images['tape-blank']
        self.tapesprite.rect = self.tapesprite.image.get_rect()
        self.tapesprite.rect.topleft = (2, 2)
        self.spritegroup.add(self.tapesprite)
        self.angersprite = pygame.sprite.Sprite()
        self.angersprite.image = g.res.images['angry-0']
        self.angersprite.rect = self.angersprite.image.get_rect()
        self.angersprite.rect.topleft = (600, 4)
        self.spritegroup.add(self.angersprite)
        self.batterysprite = pygame.sprite.Sprite()
        self.batterysprite.image = \
            self.font.render("Battery: " + str(self.battery) + "%", True,
                             (255, 255, 0))
        self.batterysprite.rect = self.batterysprite.image.get_rect()
        self.batterysprite.rect.topleft = (350, 5)
        self.spritegroup.add(self.batterysprite)
  
    def update(self, dt):
        if self.g.scene.george.state == 'filmwalk' or \
                self.g.scene.george.state == 'filmstand':
            if self.tapestate == 'off':
                self.tapestate = 'rec'
                self.tapesprite.image = self.g.res.images['tape-rec']
        else:
            if self.tapestate == 'rec':
                self.tapestate = 'off'
                self.tapesprite.image = self.g.res.images['tape-blank']
        if self.tapestate == 'rec':
            self.g.scene.score += 10.0 / 1000.0 * dt
        curscore = int(self.g.scene.score)
        if self.lastscore != curscore:
            self.lastscore = curscore
            self.scoresprite.image = \
                self.font.render("Score: " + str(self.lastscore), True,
                                 (255, 255, 0))
        if self.lastanger != self.g.scene.anger:
            self.lastanger = self.g.scene.anger
            anger = self.lastanger
            if anger > 5:
                anger = 5
            self.angersprite.image = self.g.res.images['angry-' + str(anger)]
        battery = int((self.g.scene.timethislevel - \
                           self.g.scene.timeelapsed) / \
                          self.g.scene.timethislevel * 100.0)
        if battery < 0:
            battery = 0
        if self.battery != battery:
            self.battery = battery
            self.batterysprite.image = \
                self.font.render("Battery: " + str(self.battery) + "%", True,
                                 (255, 255, 0))
        self.spritegroup.clear(self.g.screen, self.g.scene.bgimage)
        rectlist = self.spritegroup.draw(self.g.screen)
        pygame.display.update(rectlist)
        

