'''Resource manager, preloads everything so there's no slowdowns
once game is running'''

import os
import glob
import pygame

class ResourceManager(object):
    def __init__(self):
        (head, tail) = os.path.split(__file__)
        # Get miscellanous graphics
        self.images = {}
        curpath = os.path.join(os.path.split(head)[0], 
                               'data', 'miscgfx', '*.png')
        for imgpath in glob.glob(curpath):
            imgname = os.path.split(imgpath)[1].split('.')[0].lower()
            self.images[imgname] = pygame.image.load(imgpath).convert_alpha()

        # Get sprites
        self.sprites = {}
        curpath = os.path.join(os.path.split(head)[0], 
                               'data', 'sprites', '*.png')
        for imgpath in glob.glob(curpath):
            imgname = os.path.split(imgpath)[1].split('.')[0].lower()
            img = pygame.image.load(imgpath).convert_alpha()
            self.sprites[imgname] = (img, pygame.transform.flip(img, 1, 0))



        
