'''Sound manager'''

FREQ = 44100 # audio CD quality
BITSIZE = -16 # unsigned 16 bit
CHANNELS = 2 # 1 is mono, 2 is stereo
BUFFER = 1024 # number of samples

import os
import pygame

class SoundManager(object):
    def __init__(self, g):
        self.g = g
        self.musicstate = 'stopped'
        pygame.mixer.init(FREQ, BITSIZE, CHANNELS, BUFFER)
        pygame.mixer.music.set_volume(0.8)
        (head, tail) = os.path.split(__file__)
        curpath = os.path.join(os.path.split(head)[0], 
                               'data', 'sounds', 'beeep.wav')
        self.bingsound = pygame.mixer.Sound(curpath)
        curpath = os.path.join(os.path.split(head)[0], 
                               'data', 'sounds', 'miiike.wav')
        self.mikesound = pygame.mixer.Sound(curpath)

    def playmusic(self, song = 'lazybird'):
        songname = song + '.mid'
        pygame.mixer.music.stop()
        (head, tail) = os.path.split(__file__)
        curpath = os.path.join(os.path.split(head)[0], 
                               'data', 'music', songname)
        pygame.mixer.music.load(curpath)
        pygame.mixer.music.play()

    def stopmusic(self):
        pygame.mixer.music.stop()

    def bing(self):
        self.bingsound.play()

    def mike(self):
        self.mikesound.play()



        
